Name:		ceph-iscsi-cli
Version:	2.0
Release:	5%{?dist}
Summary:	CLI configuration tool to manage multiple iSCSI gateways
Group:		Applications/System
License:	GPLv3

URL:		https://github.com/pcuzner/ceph-iscsi-cli
Source0:	https://github.com/pcuzner/%{name}/archive/%{version}/%{name}-%{version}.tar.gz

Patch0001: 0001-utils-color-message-function-added.patch
Patch0002: 0002-import-layout-changes-to-PEP-guidelines.patch
Patch0003: 0003-storage-removal-of-dev-mapper-code.patch
Patch0004: 0004-PEP8-import-layout-change.patch
Patch0005: 0005-node-generic-ui_command_info-now-uses-console_messag.patch
Patch0006: 0006-setup-version-bump-to-2.1.patch
Patch0007: 0007-rbd-target-api-restructure-to-remove-flask-restful-d.patch
Patch0008: 0008-spec-version-bump-to-2.1.patch
Patch0009: 0009-utils-fix-account-for-empty-gateway-group.patch
Patch0010: 0010-storage-convert-feature-int-to-a-list-of-description.patch
Patch0011: 0011-rbd-target-api-automatically-select-best-TLS-based-o.patch
Patch0012: 0012-storage-add-feature_list-as-a-display-attribute.patch
Patch0013: 0013-node-tidy-up-list-display-for-info-commands.patch
Patch0014: 0014-man-page-Updated-to-reflect-changes-for-TCMU-and-add.patch
Patch0015: 0015-node.py-updated-generic-info-method.patch
Patch0016: 0016-Requested-command-is-now-added-to-the-log-file.patch
Patch0017: 0017-storage.py-Added-info-and-resize-commands-to-disks-s.patch
Patch0018: 0018-spec-updated-to-reflect-recent-patches.patch
Patch0019: 0019-rbd-target-api-updated-to-use-the-renamed-config-fil.patch
Patch0020: 0020-gateway-Add-UP-DOWN-check-for-each-gateway.patch
Patch0021: 0021-spec-updated-change-list.patch
Patch0022: 0022-soft-fail-client-init-failures.patch
Patch0023: 0023-add-debug-information-to-gateway-and-storage-modules.patch
Patch0024: 0024-client-block-the-addition-of-a-duplicate-LUN-to-a-cl.patch
Patch0025: 0025-enable-multiple-ceph-clusters-in-the-UI.patch
Patch0026: 0026-client-fix-disk-resize-not-being-picked-up-against-m.patch
Patch0027: 0027-storage-fix-disk-resize-now-updates-the-pool-informa.patch
Patch0028: 0028-storage-fix-pool-refresh-for-create-deletes.patch
Patch0029: 0029-gateway-decrypt-chap-password-when-exporting-for-Ans.patch
Patch0030: 0030-client-decrypt-client-chap-passwords-within-the-CLI.patch
Patch0031: 0031-spec-changelog-update.patch
Patch0032: 0032-rbd-target-api-remove-redundant-code-that-checked-lv.patch
Patch0033: 0033-gateway-fix-filename-used-in-hash-compare.patch
Patch0034: 0034-gateway-Use-console_message-for-high-level-info-comm.patch
Patch0035: 0035-gateway-port-open-check-updated-with-a-shutdown-call.patch
Patch0036: 0036-gateway-debug-text-changed-when-refreshing-gw-connec.patch
Patch0037: 0037-systemd-add-service-dependencies-between-rbd-target-.patch
Patch0038: 0038-client-after-client-is-corrected-cd-to-the-new-defin.patch
Patch0039: 0039-node-add-method-to-return-UI-root-object.patch
Patch0040: 0040-client-storage-allow-disks-to-be-autodefined-when-ma.patch
Patch0041: 0041-utils-add-port-state-function.patch
Patch0042: 0042-gateway-determine-gw-health-using-iscsi-and-API-port.patch
Patch0043: 0043-systemd-unit-fix-dependencies-between-gw-and-api-ser.patch
Patch0044: 0044-node-fix-to-formatting-of-the-info-command.patch
Patch0045: 0045-gateway-fix-gateways-info-command-now-uses-console_m.patch
Patch0046: 0046-gwcli-add-__version__-and-set-a-flag-to-denote-inter.patch
Patch0047: 0047-utils-updated-console_message-to-change-output-if-ru.patch

BuildArch:  noarch

BuildRequires: python-devel
BuildRequires: python-setuptools
BuildRequires: systemd

Requires: python-rtslib >= 2.1.fb64-0.1
Requires: ceph-iscsi-config >= 2.0-4
Requires: python-configshell >= 1.1
Requires: python-flask >= 0.10.1
Requires: python-requests >= 2.6
Requires: pyOpenSSL >= 0.1

%description
This package provides a CLI interface similar to the targetcli tool used to
interact with the kernel LIO subsystem. The rpm installs two components; a CLI
shell (based on configshell) and an API service called rbd-target-api.

The CLI orchestrates iscsi configuration changes through the API service
running on EACH gateway node. The API service uses the same configuration
settings file '/etc/ceph/iscsi-gateway.conf' as the rbd-target-gw service.

You should ensure that this 'conf' file is consistent across gateways for
consistent behaviour.

%prep
%setup -q 

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1
%patch0037 -p1
%patch0038 -p1
%patch0039 -p1
%patch0040 -p1
%patch0041 -p1
%patch0042 -p1
%patch0043 -p1
%patch0044 -p1
%patch0045 -p1
%patch0046 -p1
%patch0047 -p1

%build
CFLAGS="$RPM_OPT_FLAGS" %{__python} setup.py build


%install
%{__python} setup.py install --skip-build --root %{buildroot} --install-scripts %{_bindir}
mkdir -p %{buildroot}%{_unitdir}
install -m 0644 .%{_unitdir}/rbd-target-api.service %{buildroot}%{_unitdir}
mkdir -p %{buildroot}%{_mandir}/man8
install -m 0644 gwcli.8 %{buildroot}%{_mandir}/man8/
gzip %{buildroot}%{_mandir}/man8/gwcli.8

%post
/bin/systemctl --system daemon-reload &> /dev/null || :
/bin/systemctl --system enable rbd-target-api &> /dev/null || :

%files
%doc README
%doc LICENSE
%{_bindir}/gwcli
%{_bindir}/rbd-target-api
%{_unitdir}/rbd-target-api.service
%{python2_sitelib}/*
%{_mandir}/man8/gwcli.8.gz

%changelog
* Wed Jun 07 2017 Jason Dillaman <dillaman@redhat.com> 2.0-5
- bumped ceph-iscsi-config and python-rtslib required versions

* Wed Apr 26 2017 Jason Dillaman <dillaman@redhat.com> 2.0-4
- utils: updated console_message to change output if running in batch mode
- gwcli: add __version__ and set a flag to denote interactive/batch mode
- gateway: fix - gateways info command now uses console_msg function
- node: fix to formatting of the info command
- systemd unit: fix dependencies between gw and api services
- gateway: determine gw health using iscsi and API port states
- utils: add port state function
- client/storage: allow disks to be autodefined when managing a client
- node: add method to return UI root object
- client: after client is corrected, cd to the new definition
- systemd : add service dependencies between rbd-target-gw and rbd-target-api
- gateway: debug text changed when refreshing gw connection state
- gateway: port open check updated with a shutdown call
- gateway: Use console_message for high level info command
- gateway: fix filename used in hash compare
- rbd-target-api: remove redundant code that checked lvm.conf
- spec: changelog update
- client: decrypt client chap passwords within the CLI
- gateway: decrypt chap password when exporting for Ansible
- storage: fix - pool refresh for create/deletes
- storage: fix - disk resize now updates the pool information
- client: fix - disk resize not being picked up against mapped luns
- enable multiple ceph clusters in the UI
- client: block the addition of a duplicate LUN to a client
- add debug information to gateway and storage modules
- soft fail client init failures
- spec: updated change list
- gateway: Add UP/DOWN check for each gateway
- rbd-target-api: updated to use the renamed config file *.cfg
- spec: updated to reflect recent patches
- storage.py: Added info and resize commands to /disks subtree
- Requested command is now added to the log file
- node.py: updated generic info method
- man-page: Updated to reflect changes for TCMU, and addition of resize cmd
- node: tidy up list display for info commands
- rbd-target-api: automatically select best TLS based on werkzeug version
- spec: version bump to 2.1
- rbd-target-api: restructure to remove flask-restful dependencies
- setup: version bump to 2.1

* Fri Jan 13 2017 Jason Dillaman <dillaman@redhat.com> 2.0-3
- storage:add feature_list as a display attribute
- rbd-target-api: automatically select best TLS based on werkzeug version
- storage: convert feature int to a list of descriptions
- utils: fix - account for empty gateway group

* Wed Jan 11 2017 Jason Dillaman <dillaman@redhat.com> 2.0-2
- rbd-target-api: restructure to remove flask-restful dependencies
- node: generic ui_command_info now uses console_message function
- PEP8 import layout change
- storage: removal of dev-mapper code
- import layout changes to PEP guidelines
- utils: color message function added

* Thu Jan 5 2017 Paul Cuzner <pcuzner@redhat.com> 2.0-1
- initial rpm packaging (rhbz#1410133)


